/**
 * Copyright (c) Tiny Technologies, Inc. All rights reserved.
 * Licensed under the LGPL or a commercial license.
 * For LGPL see License.txt in the project root for license information.
 * For commercial licenses see https://www.tiny.cloud/
 *
 * Version: 5.10.5 (2022-05-25)
 */
!(function () {
  'use strict'
  function a(e) {
    return e.getAttribute('id') || e.getAttribute('name') || ''
  }
  function c(e) {
    return e && 'a' === e.nodeName.toLowerCase() && !e.getAttribute('href') && '' !== a(e)
  }
  function d(e) {
    return e.dom.getParent(e.selection.getStart(), l)
  }
  function r(e, t) {
    var o,
      a,
      n,
      r,
      i,
      l = d(e)
    l
      ? ((n = e),
        (r = t),
        (i = l).removeAttribute('name'),
        (i.id = r),
        n.addVisual(),
        n.undoManager.add())
      : ((a = t),
        (o = e).undoManager.transact(function () {
          var e, n
          o.getParam('allow_html_in_named_anchor', !1, 'boolean') || o.selection.collapse(!0),
            o.selection.isCollapsed()
              ? o.insertContent(o.dom.createHTML('a', { id: a }))
              : ((n = (e = o).dom),
                u(n).walk(e.selection.getRng(), function (e) {
                  s.each(e, function (e) {
                    var t
                    c((t = e)) && !t.firstChild && n.remove(e, !1)
                  })
                }),
                o.formatter.remove('namedAnchor', null, null, !0),
                o.formatter.apply('namedAnchor', { value: a }),
                o.addVisual())
        })),
      e.focus()
  }
  // 补充判断浏览器方法---------------
  function V(e) {
    function t(e) {
      return function () {
        return n === e
      }
    }
    var n = e.current,
      r = e.version
    return {
      current: n,
      version: r,
      isEdge: t('Edge'),
      isChrome: t('Chrome'),
      isIE: t('IE'),
      isOpera: t('Opera'),
      isFirefox: t(ne),
      isSafari: t('Safari'),
    }
  }
  function W(e) {
    function t(e) {
      return function () {
        return n === e
      }
    }
    var n = e.current,
      r = e.version
    return {
      current: n,
      version: r,
      isWindows: t(ie),
      isiOS: t('iOS'),
      isAndroid: t(ae),
      isOSX: t('OSX'),
      isLinux: t('Linux'),
      isSolaris: t(se),
      isFreeBSD: t(ue),
      isChromeOS: t(ce),
    }
  }
  function S(e) {
    return function () {
      return e
    }
  }
  function U(e, t) {
    return -1 !== e.indexOf(t)
  }
  function _(t) {
    return function (e) {
      return U(e, t)
    }
  }
  var ee = /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
    te = {
      browsers: S([
        {
          name: 'Edge',
          versionRegexes: [/.*?edge\/ ?([0-9]+)\.([0-9]+)$/],
          search: function (e) {
            return U(e, 'edge/') && U(e, 'chrome') && U(e, 'safari') && U(e, 'applewebkit')
          },
        },
        {
          name: 'Chrome',
          brand: 'Chromium',
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/, ee],
          search: function (e) {
            return U(e, 'chrome') && !U(e, 'chromeframe')
          },
        },
        {
          name: 'IE',
          versionRegexes: [/.*?msie\ ?([0-9]+)\.([0-9]+).*/, /.*?rv:([0-9]+)\.([0-9]+).*/],
          search: function (e) {
            return U(e, 'msie') || U(e, 'trident')
          },
        },
        {
          name: 'Opera',
          versionRegexes: [ee, /.*?opera\/([0-9]+)\.([0-9]+).*/],
          search: _('opera'),
        },
        {
          name: 'Firefox',
          versionRegexes: [/.*?firefox\/\ ?([0-9]+)\.([0-9]+).*/],
          search: _('firefox'),
        },
        {
          name: 'Safari',
          versionRegexes: [ee, /.*?cpu os ([0-9]+)_([0-9]+).*/],
          search: function (e) {
            return (U(e, 'safari') || U(e, 'mobile/')) && U(e, 'applewebkit')
          },
        },
      ]),
      oses: S([
        {
          name: 'Windows',
          search: _('win'),
          versionRegexes: [/.*?windows\ nt\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'iOS',
          search: function (e) {
            return U(e, 'iphone') || U(e, 'ipad')
          },
          versionRegexes: [
            /.*?version\/\ ?([0-9]+)\.([0-9]+).*/,
            /.*cpu os ([0-9]+)_([0-9]+).*/,
            /.*cpu iphone os ([0-9]+)_([0-9]+).*/,
          ],
        },
        {
          name: 'Android',
          search: _('android'),
          versionRegexes: [/.*?android\ ?([0-9]+)\.([0-9]+).*/],
        },
        {
          name: 'OSX',
          search: _('mac os x'),
          versionRegexes: [/.*?mac\ os\ x\ ?([0-9]+)_([0-9]+).*/],
        },
        { name: 'Linux', search: _('linux'), versionRegexes: [] },
        { name: 'Solaris', search: _('sunos'), versionRegexes: [] },
        { name: 'FreeBSD', search: _('freebsd'), versionRegexes: [] },
        {
          name: 'ChromeOS',
          search: _('cros'),
          versionRegexes: [/.*?chrome\/([0-9]+)\.([0-9]+).*/],
        },
      ]),
    },
    ne = 'Firefox',
    re = function () {
      return V({ current: void 0, version: G.unknown() })
    },
    oe = V,
    ie = (S('Edge'), S('Chrome'), S('IE'), S('Opera'), S(ne), S('Safari'), 'Windows'),
    ae = 'Android',
    se = 'Solaris',
    ue = 'FreeBSD',
    ce = 'ChromeOS',
    fe = function () {
      return W({ current: void 0, version: G.unknown() })
    }
  // ---------------
  function i(r) {
    return function (e) {
      for (var t, n = 0; n < e.length; n++) {
        var o = e[n],
          a = void 0
        !(a = t = o) ||
          a.attr('href') ||
          (!a.attr('id') && !a.attr('name')) ||
          t.firstChild ||
          o.attr('contenteditable', r)
      }
    }
  }
  var e = tinymce.util.Tools.resolve('tinymce.PluginManager'),
    u = tinymce.util.Tools.resolve('tinymce.dom.RangeUtils'),
    s = tinymce.util.Tools.resolve('tinymce.util.Tools'),
    l = 'a:not([href])'
  e.add('anchor', function (e) {
    var t, n, o
    ;(t = e).on('PreInit', function () {
      t.parser.addNodeFilter('a', i('false')), t.serializer.addNodeFilter('a', i(null))
    }),
      (n = e).addCommand('mceAnchor', function () {
        var o, e, t
        ;(t = (e = d((o = n))) ? a(e) : ''),
          o.windowManager.open({
            title: 'Anchor',
            size: 'normal',
            body: {
              type: 'panel',
              items: [{ name: 'id', type: 'input', label: 'ID', placeholder: 'example' }],
            },
            buttons: [
              { type: 'cancel', name: 'cancel', text: 'Cancel' },
              { type: 'submit', name: 'save', text: 'Save', primary: !0 },
            ],
            initialData: { id: t },
            onSubmit: function (e) {
              var t = o,
                n = e.getData().id
              ;(/^[A-Za-z][A-Za-z0-9\-:._]*$/.test(n)
                ? (r(t, n), 0)
                : (t.windowManager.alert(
                    'Id should start with a letter, followed only by letters, numbers, dashes, dots, colons or underscores.'
                  ),
                  1)) || e.close()
            },
          })
      }),
      (o = e).ui.registry.addToggleButton('anchor', {
        icon: 'bookmark',
        tooltip: 'Anchor',
        onAction: function () {
          return o.execCommand('mceAnchor')
        },
        onSetup: function (e) {
          return o.selection.selectorChangedWithUnbind('a:not([href])', e.setActive).unbind
        },
      }),
      o.ui.registry.addMenuItem('anchor', {
        icon: 'bookmark',
        text: 'Anchor...',
        onAction: function () {
          return o.execCommand('mceAnchor')
        },
      }),
      e.on('PreInit', function () {
        e.formatter.register('namedAnchor', {
          inline: 'a',
          selector: l,
          remove: 'all',
          split: !0,
          deep: !0,
          attributes: { id: '%value' },
          onmatch: c,
        })
      })
  })
})()
